33a34,35
> #define WITH_EXT
> 
92a95
> static const char *string_file_ext (file_entry *, int);
149c152,156
<      string_file_name,          /* TODO: string_file_ext */
---
> #ifdef WITH_EXT
>      string_file_ext,          /* TODO: string_file_ext */
> #else
>      string_file_name          /* TODO: string_file_ext */
> #endif
324a332,334
> #ifdef WITH_TABS
> #define llines(p) (WIDGET (p)->lines - 3 - (panels_options.show_mini_info ? 4 : 2) + (tabs_options.hide_tabs ? 2 : 0))
> #else
325a336
> #endif
458a470,499
> #ifdef WITH_EXT
> static const char *
> string_file_ext (file_entry * fe, int len)
> {
>     static char buffer[MC_MAXPATHLEN * MB_LEN_MAX + 1];
>     static char empty[MC_MAXPATHLEN * MB_LEN_MAX + 1];
> 
>     int i;
> 
>     (void) len;
> 
>     g_strlcpy(empty, "", sizeof(buffer));
> 
>     if ((S_ISDIR (fe->st.st_mode) || fe->f.link_to_dir) && !DIR_IS_DOTDOT (fe->fname)){
>         return empty;
>     }
> 
>     for (i = strlen(fe->fname) - 2; i >= 0; i--){
>         if (fe->fname[i] == '.'){
>             g_strlcpy (buffer, fe->fname + i + 1, sizeof (buffer));
>             break;
>         }
>     }
>     if (strlen(fe->fname) < 2 || i == -1 || fe->fname[strlen(fe->fname) - 1] == '.'){
>         return empty;
>     }
> 
>     return buffer;
> }
> #endif
1254a1296
> #ifndef WITH_TABS
1256a1299
> #endif
1459a1503,1506
> #ifdef WITH_TABS
>     destroy_tabs(p);
> #endif
> 
2550a2598,2600
> #ifdef WITH_TABS
>     draw_tabs(panel);
> #endif
3418a3469,3471
> #ifdef WITH_TABS
>         draw_tabs(get_other_type () != view_listing || get_current_type() != view_listing ? panel : NULL);
> #endif
3446a3500,3502
> #ifdef WITH_TABS
>         draw_tabs(get_other_type () != view_listing || get_current_type() != view_listing ? panel : NULL);
> #endif
4116a4173,4176
> #ifdef WITH_TABS
>     create_tab(panel, dir_next); 
> #endif
> 
4604d4663
< 
4780d4838
< 
4835a4894,5613
> #ifdef WITH_TABS
> /**
>  * This function will create a new tab in the current panel
>  */
> void new_tab(void)
> {
>     WPanel *panel = (WPanel *) current_panel;
>     enum tabs_direction d;
>     if (tabs_options.open_where == BEFORE_CURRENT){
>         d = dir_previous;
>     }
>     else if (tabs_options.open_where == AFTER_CURRENT){
>         d = dir_next;
>     }
>     else if (tabs_options.open_where == AT_END){
>         d = dir_last;
>     }
>     else if (tabs_options.open_where == AT_BEGINNING){
>         d = dir_first;
>     }
>     create_tab(panel, d);
>     change_tab(panel, d, NULL);
>     draw_tabs(panel);
> }
> 
> /**
>  * This function will close a tab
>  * @return void
>  */
> void close_tab(void)
> {
>     WPanel *p = current_panel;
>     if (p->tabs->next == p->tabs){
>         message (D_ERROR, MSG_ERROR, _("The current tab is the only one.\nYou cannot close it."));
>     }
>     else {
>         int first = p->tabs_current == p->tabs;
>         GList *b = p->tabs_current->prev;
>         GList *c = p->tabs_current;
>         GList *d = p->tabs_current->next;
>         change_tab(p, dir_previous, NULL);
>         b->next = d;
>         d->prev = b;
> 
>         destroy_tab(c->data);
>         g_free(c);
> 
>         if (first){
>             p->tabs = d;
>         }
>     }
> }
> 
> /**
>  * This function renames a tab
>  * @return void
>  */
> void rename_tab(void)
> {
>     WPanel *p = current_panel;
>     Tab *t = (Tab *) p->tabs_current->data;
>     char *title = get_tab_title(p, t, MAX_TAB_TITLE); 
> 
>     char *name = input_dialog(_("Tab rename"), _("Please enter the new name:"), NULL, title, INPUT_COMPLETE_NONE);
>     if (name){
>         if (strlen(name)){
>             t->name = g_new0(char, strlen(name) + 1);
>             strcpy(t->name, name);
>             g_free(name);
>             g_free(title); 
>         }
>     }
>     widget_redraw((Widget *) p);
> }
> 
> /**
>  * This function goes to the next tab
>  * @return void
>  */
> void next_tab(void)
> {
>     WPanel *p = current_panel;
>     change_tab(p, dir_next, NULL); 
> }
> 
> /**
>  * This function goes to the previous tab
>  * @return void
>  */
> void prev_tab(void)
> {
>     WPanel *p = current_panel;
>     change_tab(p, dir_previous, NULL); 
> }
> 
> int get_tab_index(WPanel *p, GList *t)
> {
>     int result = 0;
>     GList *i = p->tabs;
>     do {
>         if (i == t){
>             return result;
>         }
>         result++;
>         i = i->next;
>     } while (i != p->tabs);
> 
>     return 0;
> }
> 
> /**
>  * This function goes to an arbitrary choosen tab
>  * @return void
>  */
> void goto_tab(void)
> {
>     Listbox *listbox = create_listbox_window (15, 60, _("Available Tabs"), "[Available Tabs Selector]");
> 
>     WPanel *p = current_panel;
>     GList *it = p->tabs;
>     int items = 0;
>     int result;
>     do {
>         char *title = get_tab_title(p, (Tab *) it->data, MAX_TAB_TITLE);
>         listbox_add_item (listbox->list, LISTBOX_APPEND_AT_END, 0, title, (void *) it);
>         it = it->next;
>         items++;
>     } while (it != p->tabs); 
> 
>     listbox_select_entry(listbox->list, get_tab_index(current_panel, p->tabs_current)); 
> 
>     result = run_listbox(listbox); 
> 
>     if (result >= 0){
>         GList *t;
>         t = g_list_nth ((GList *) p->tabs, result);
>         change_tab(p, dir_absolute, t);
>     }
> }
> 
> void create_tab(WPanel *p, enum tabs_direction direction)
> {
>     GList *b;
>     Tab *t = g_new0(Tab, 1);
>     GList *c = g_new0(GList, 1);
> 
>     t->path = NULL;
>     t->name = NULL;
> 
>     if (direction == dir_next){
>         b = p->tabs_current;
>     }
>     else if (direction == dir_previous){
>         b = p->tabs_current->prev;
>     }
>     else if (direction == dir_last || direction == dir_first){
>         b = p->tabs->prev;
>     }
>     c->data = t;
>     
>     if (b){
>         GList *d = b->next;
>         b->next = c;
>         c->next = d;
>         d->prev = c;
>         c->prev = b;
>     }
>     else {
>         c->next = c;
>         c->prev = c;
>         p->tabs_current = c;
>     }
> 
>     if (!p->tabs){
>         p->tabs = c;
>     }
> 
>     if (direction == dir_first){
>         p->tabs = c;
>     }
> 
> }
> 
> GList *get_tab_by_index(WPanel *p, int idx)
> {
>     int i = 0;
>     GList *t = p->tabs;
> 
>     while (i++ < idx){
>         t = t->next;
>     }
> 
>     return t;
> }
>     
> RestoredTabs _restore_tabs(FILE *f)
> {
>     RestoredTabs result;
>     Tab *t;
>     int idx = 0;
>     int crt_idx;
>     GList *i;
>     GList *j;
>     char *line = g_new0(char, 1024);
> 
>     result.error = 0;
>     result.tabs = NULL;
>     fscanf(f, "%d\n%d\n", &result.idx, &crt_idx);
> 
>     do {
>         read_line(line, 1024, f);
>         if (strcmp(line, "") && !feof(f)){
>             t = g_new0(Tab, 1);
>             if (!strcmp(line, "(null)")){
>                 t->name = NULL;
>             }
>             else {
>                 t->name = g_new0(char, strlen(line) + 1);
>                 memcpy(t->name, line, strlen(line) + 1);
>             }
> 
>             read_line(line, 1024, f); 
>             if (!strcmp(line, "")){
>                 result.error = 1;
>                 return result;
>             }
>             t->path = vfs_path_from_str(line);
> 
>             i = g_new0(GList, 1);
>             i->data = (void *) t;
> 
>             if (result.tabs == NULL){
>                 result.tabs = i;
>                 result.tabs->prev = result.tabs;
>                 j = i;
>             }
>             i->next = result.tabs;
>             result.tabs->prev = i;
>             i->prev = j;
>             j->next = i;
>             j = i;
> 
>             if (idx++ == crt_idx){
>                 result.tab_current = j;
>             }
>         }
>     } while (!feof(f) && strcmp(line, "") && !result.error);
>     
>     g_free(line);
> 
>     return result;
> }
> 
> void abort_restore(RestoredTabs restored)
> {
>     WPanel *tmp = g_new0(WPanel, 1);
>     tmp->tabs = restored.tabs;
>     destroy_tabs(tmp);
>     message (D_ERROR, MSG_ERROR, _("Error restoring the tabs."));
>     g_free(tmp);
> }
> 
> void read_line(char *line, int max, FILE *f)
> {
>     fgets(line, max, f);
>     if (line[strlen(line) - 1] == '\n'){
>         line[strlen(line) - 1] = '\0';
>     }
> }
> 
> void restore_tabs_session(char *title)
> {
>     char *file_name = g_new0(char, strlen(tabs_options.sessions_folder) + 1 + strlen(title) + 1);
>     RestoredTabs restored1, restored2;
>     char *line = g_new0(char, 1024);
>     Tab *t;
> 
>     restored1.tabs = restored1.tab_current = restored2.tabs = restored2.tab_current = NULL;
> 
>     sprintf(file_name, "%s/%s", tabs_options.sessions_folder, title);
> 
>     if (exist_file(file_name)){
>         FILE *f = fopen(file_name, "rt");
>         read_line(line, 1024, f);
>         if (strcmp(line, "[Current Panel]")){
>             abort_restore(restored1); 
>             g_free(line); g_free(file_name); 
>             return ;
>         }
> 
>         restored1 = _restore_tabs(f);
>         if (restored1.error){
>             abort_restore(restored1); 
>             g_free(line); g_free(file_name); 
>             return ;
>         }
>         read_line(line, 1024, f);
>         if (strcmp(line, "[Other Panel]")) {
>             abort_restore(restored1); 
>             g_free(line); g_free(file_name); 
>             return ;
>         }
>         restored2 = _restore_tabs(f);
>         if (restored2.error){
>             abort_restore(restored1);
>             abort_restore(restored2);
>             g_free(line); g_free(file_name); 
>             return ;
>         }
> 
>         fclose(f);
>         destroy_tabs(current_panel);
>         destroy_tabs(other_panel);
> 
>         current_panel->tabs = restored1.tabs;
>         current_panel->tabs_current = restored1.tab_current;
> 
>         other_panel->tabs = restored2.tabs;
>         other_panel->tabs_current = restored2.tab_current;
> 
>         t = (Tab *) other_panel->tabs_current->data;
>         do_panel_cd(other_panel, t->path, cd_exact); 
> 
>         t = (Tab *) current_panel->tabs_current->data;
>         do_panel_cd(current_panel, t->path, cd_exact); 
> 
>         if (get_current_index() != restored1.idx){
>             swap_panels();
>             if (restored1.idx != 0){
>                 //change_panel();
>             }
>         }
>     }
>     g_free(line); g_free(file_name); 
> }
> 
> void _write_tabs(FILE *f, WPanel *p)
> {
>     GList *i = p->tabs;
>     Tab *t;
>     int crt = get_tab_index(p, p->tabs_current); 
>     fprintf(f, "%d\n", crt); 
>     do {
>         t = (Tab *) i->data;
>         fprintf(f, "%s\n%s\n", t->name ? t->name : "(null)", vfs_path_as_str(i == p->tabs_current ? p->cwd_vpath : t->path));
>         i = i->next;
>     } while (i != p->tabs);
> }
> 
> void save_tabs_session(char *title)
> {
>     char *file_name = g_new0(char, strlen(tabs_options.sessions_folder) + 1 + strlen(title) + 1);
>     FILE *f;
>     sprintf(file_name, "%s/%s", tabs_options.sessions_folder, title);
> 
>     f = fopen(file_name, "wt");
> 
>     fprintf(f, "[Current Panel]\n%d\n", get_current_index());
>     _write_tabs(f, current_panel);
>     fprintf(f, "\n[Other Panel]\n%d\n", get_other_index());
>     _write_tabs(f, other_panel);
>     fclose(f);
>     g_free(file_name);
> }
> 
> void save_tabs_session_custom(void)
> {
>     char *name = input_dialog(_("Save custom tabs session"), _("Please enter the session name:"), NULL, "", INPUT_COMPLETE_NONE);
>     if (name){
>         if (strlen(name)){
>             save_tabs_session(name);
>         }
> 
>         g_free(name); 
>     }
> }
> 
> void restore_tabs_session_custom(void)
> {
>     Listbox *listbox = create_listbox_window (15, 60, _("Available Sessions"), "[Available Sessions Selector]");
>     struct dirent *entry;
>     DIR *dir;
>     char *name;
>     GList *items, *last, *current;
>     int result;
>     GList *t;
>     GList *i;
> 
>     dir = opendir(tabs_options.sessions_folder);
> 
>     items = NULL;
> 
>     while ((entry = readdir(dir)) != NULL){
>         if (strcmp(entry->d_name, ".") && strcmp(entry->d_name, "..")){
>             name = g_new0(char, 255);
>             memmove(name, entry->d_name, strlen(entry->d_name) + 1);
>             last = g_new0(GList, 1); 
>             last->data = name;
>             last->next = NULL;
>             if (items == NULL){
>                 items = last;
>                 current = last;
>             }
>             else {
>                 current->next = last;
>             }
>             current = last;
>             listbox_add_item (listbox->list, LISTBOX_APPEND_AT_END, 0, entry->d_name, (void *) name);
>         }
>     }
> 
>     result = run_listbox(listbox); 
> 
>     if (result >= 0){
>         t = g_list_nth ((GList *) items, result);
>         restore_tabs_session((char *) t->data); 
>     }
> 
>     i = items;
>     while (i){
>         name = (char *) i->data;
>         i = i->next;
>         g_free(name); 
>     }
> }
> 
> void change_tab(WPanel *p, enum tabs_direction d, GList *tab)
> {
>     if (p->tabs_current){
>         Tab *t = (Tab *) p->tabs_current->data;
>         if (t->path){
>             vfs_path_free(t->path);
>         }
> 
>         //t->path = (vfs_path_t *) g_memdup(p->cwd_vpath, sizeof(vfs_path_t));
>         t->path = vfs_path_clone(p->cwd_vpath); 
> 
>         if (d == dir_next){
>             p->tabs_current = p->tabs_current->next;
>         }
>         else if (d == dir_previous){
>             p->tabs_current = p->tabs_current->prev;
>         }
>         else if (d == dir_first){
>             p->tabs_current = p->tabs;
>         }
>         else if (d == dir_last){
>             p->tabs_current = p->tabs->prev;
>         }
>         else if (tab != NULL) {
>             p->tabs_current = tab; 
>         }
> 
>         t = (Tab *) p->tabs_current->data;
>         if (t->path){
>             do_panel_cd(p, t->path, cd_exact); 
>         }
>     }
> }
> 
> void destroy_tab(Tab *t)
> {
>     if (t->path){
>         vfs_path_free(t->path);
>     }
>     if (t->name){
>         g_free(t->name); 
>     }
>     g_free(t);
> }
> 
> void destroy_tabs(WPanel *p)
> {
>     GList *i;
>     Tab *t;
>     int loop; 
>     if (p->tabs == NULL){
>         return ;
>     }
> 
>     loop = p->tabs != p->tabs->next;
> 
>     p->tabs->prev->next = NULL;
> 
>     do {
>         i = p->tabs;
>         if (i){
>             t = (Tab *) i->data;
>             p->tabs = p->tabs->next;
>             destroy_tab(t);
>             g_free(i);
>         }
>     } while (p->tabs && loop);
> }
> 
> int draw_tab(char *title, int selected, enum tabs_scroll_flags scroll)
> {
>     if (selected){
>         tty_setcolor(SELECTED_COLOR);
>     }
>     tty_print_string(scroll == SCROLL_LEFT ? "<" : " ");
>     tty_print_string(title);
>     tty_print_string(scroll == SCROLL_RIGHT ? ">" : " ");
>     tty_setcolor(NORMAL_COLOR); 
>     tty_print_one_vline (TRUE);
> 
>     return strlen(title) + 3; 
> }
> 
> void cut_title(char *title, int max)
> {
>     title[max] = '\0';
>     title[max - 1] = '.';
>     title[max - 2] = '.';
>     title[max - 3] = '.';
> }
> 
> char *get_tab_title(WPanel *p, Tab *t, unsigned int max)
> {
>     char *result = g_new0(char, 255);
>     vfs_path_t *path;
>     size_t c;
>     Widget *w = (Widget *) p;
> 
>     if (max > (unsigned int) w->cols - 5 || max == 0){
>         max = w->cols - 5;
>     }
> 
>     if (t->name){
>         memcpy(result, t->name, strlen(t->name) + 1);
>         if (max != 0 && strlen(t->name) > max){
>             cut_title(result, max);
>         }
>         return result;
>     }
> 
>     if (t != p->tabs_current->data){
>         if (!t->path){
>             strcpy(result, "Error"); 
>             return result;
>         }
>         path = t->path;
>     }
>     else {
>         path = p->cwd_vpath;
>     }
> 
>     c = vfs_path_tokens_count(path);
>     if (c == 0){
>         strcpy(result, "/");
>         return result;
>     }
>     g_free(result);
>     result = vfs_path_tokens_get(path, c-1, 1);
>     if (max != 0 && strlen(result) > max){
>         cut_title(result, max);
>     }
>     return result;
> }
> 
> TabDisplayInfo *display_info(WPanel *p, Widget *w)
> {
>     int length = 0;
>     int max_length = w->cols - 2;
>     char *title;
>     TabDisplayInfo *result = g_new0(TabDisplayInfo, 1);
>     GList *i;
>     
>     result->start_tab = p->tabs_current;
>     result->end_tab = p->tabs_current;
>     result->start_idx = 0;
>     result->end_idx = -1;
>     result->scroll = NO_SCROLL;
> 
>     i = p->tabs_current;
>     title = get_tab_title(p, (Tab *) i->data, MAX_TAB_TITLE);
>     length += strlen(title) + 3;
>     g_free(title);
>     if (p->tabs_current != p->tabs){
>         do {
>             i = i->prev;
>             title = get_tab_title(p, (Tab *) i->data, MAX_TAB_TITLE);
>             length += strlen(title) + 3;
>             result->start_tab = i;
>             g_free(title);
>         } while(i != p->tabs && length < max_length);
> 
>         if (length >= max_length){
>             result->scroll = result->scroll | SCROLL_LEFT;
>             title = get_tab_title(p, (Tab *) result->start_tab->data, MAX_TAB_TITLE); 
>             if ((100 + strlen(title) - length + max_length) < 102){
>                 result->start_tab = result->start_tab->next;
>                 result->start_idx = 0;
>             }
>             else {
>                 result->start_idx = length - max_length;
>             }
>             g_free(title);
>         }
> 
>     }
> 
>     if (p->tabs_current != p->tabs->prev && i == p->tabs && length < max_length){
>         for (i = p->tabs_current->next; i != p->tabs && length < max_length; i = i->next){
>             title = get_tab_title(p, (Tab *) i->data, MAX_TAB_TITLE);
>             length += strlen(title) + 3;
>             result->end_tab = i;
>             g_free(title);
>         }
> 
>         if (length >= max_length){
>             result->scroll = result->scroll | SCROLL_RIGHT;
>             title = get_tab_title(p, (Tab *) result->end_tab->data, MAX_TAB_TITLE);
>             if ((100 + strlen(title) - length + max_length) < 102){
>                 result->end_tab = result->end_tab->prev;
>                 result->end_idx = -1;
>             }
>             else {
>                 result->end_idx = strlen(title) - length + max_length;
>             }
>             g_free(title);
>         }
>     }
>     else if (p->tabs_current != p->tabs->prev && length >= max_length){
>         result->scroll = result->scroll | SCROLL_RIGHT;
>     }
> 
>     return result;
> }
> 
> void draw_tabs(WPanel *panel)
> {
>     WPanel *p = (panel == NULL ? current_panel : panel);
>     Widget *w;
>     char *title;
>     int x, y, length;
>     enum tabs_scroll_flags scroll;
>     GList *i;
>     TabDisplayInfo *info;
> 
>     if (tabs_options.hide_tabs){
>         return ;
>     }
>     do {
>         // if (current_panel->frame_size == frame_full && p != current_panel){
>         //     break; 
>         // }
>         if (p->tabs == NULL){
>             break;
>         }
>         tty_setcolor(NORMAL_COLOR); 
>         w = (Widget *) p;
> 
>         x = w->x + 1;
>         y = w->y + w->lines - (the_menubar->is_visible ? 3 : 4); //w->lines - (the_menubar->is_visible ? 2 : 3);
>         length = w->cols - 2;
> 
>         tty_gotoyx(y, x);
>         tty_draw_hline (y, x, ACS_HLINE, w->cols - 2);
> 
>         tty_gotoyx(y + 1, x);
> 
>         info = display_info(p, w);
>         i = info->start_tab;
>         if (i){
>             do {
>                 title = get_tab_title(p, (Tab *) i->data, MAX_TAB_TITLE);
>                 if (i == info->start_tab && info->start_idx != 0){
>                     int l = strlen(title) - info->start_idx;
>                     char *title2 = g_new0(char, l + 1);
>                     memcpy(title2, title + info->start_idx, l + 1);
>                     memcpy(title, title2, strlen(title2));
>                     title[l] = '\0';
>                     g_free(title2);
>                 }
>                 if (i == info->end_tab && info->end_idx != -1){
>                     title[info->end_idx] = '\0';
>                 }
>                 scroll = NO_SCROLL;
>                 if (i == info->start_tab){
>                     scroll = (info->scroll & SCROLL_LEFT ) == SCROLL_LEFT ? SCROLL_LEFT : NO_SCROLL;
>                 }
>                 else if (i == info->end_tab){
>                     scroll = (info->scroll & SCROLL_RIGHT ) == SCROLL_RIGHT ? SCROLL_RIGHT : NO_SCROLL;
>                 }
>                 length -= draw_tab(title, i == p->tabs_current && p == current_panel, scroll);
>                 g_free(title);
>                 i = i->next;
>             } while (i != info->end_tab->next); 
>         }
>         g_free(info); 
> 
>         tty_print_string(str_fit_to_term(" ", length, J_LEFT));
> 
>         if (panel != NULL){
>             break;
>         }
> 
>         if (p == other_panel){
>             p = NULL;
>         }
>         else {
>             p = other_panel;
>         }
>     } while (p);
> }
> 
> void hide_tabs(void)
> {
>     WPanel *p = current_panel;
>     Widget *w = WIDGET (p);
> 
>     int x = w->x + 1, y = w->lines - (the_menubar->is_visible ? 2 : 3);
> 
>     tty_gotoyx(y, x);
>     tty_print_string(str_fit_to_term(" ", w->cols - 2, J_LEFT));
>     tty_gotoyx(y + 1, x);
>     tty_print_string(str_fit_to_term(" ", w->cols - 2, J_LEFT));
> }
> #endif
