151a152,160
> #ifdef WITH_TABS
> tabs_options_t tabs_options = {
>     .open_where = AFTER_CURRENT, 
>     .hide_tabs = FALSE, 
>     .restore_on_load = TRUE, 
>     .sessions_folder = NULL
> };
> #endif
> 
227a237,239
> #ifdef WITH_TABS
> static char *tabs_sessions_folder = NULL; /*${XDG_CONFIG_HOME}/mc/tabs.sessions */
> #endif
407a420,430
> #ifdef WITH_TABS
> static const struct
> {
>     const char *opt_name;
>     gboolean *opt_addr;
> } tabs_ini_options[] = {
>     { "hide_tabs", &tabs_options.hide_tabs },
>     { "restore_on_load", &tabs_options.restore_on_load },
>     { NULL, NULL }
> };
> #endif
943a967,976
> #ifdef WITH_TABS
>     tabs_sessions_folder = mc_config_get_full_path (MC_TABS_SESSION_SUBDIR);
> 
>     tabs_options.sessions_folder = tabs_sessions_folder;
>     //memcpy(tabs_options.sessions_folder, tabs_sessions_folder, strlen(tabs_sessions_folder) + 1);
> 
>     if (!exist_file(tabs_sessions_folder)){
>         mkdir(tabs_sessions_folder, S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);
>     }
> #endif
982a1016,1018
> #ifdef WITH_TABS
>     tabs_load_options();
> #endif
1094a1131,1133
> #ifdef WITH_TABS
>         tabs_save_options ();
> #endif
1149a1189,1191
> #ifdef WITH_TABS
>     g_free(tabs_sessions_folder); 
> #endif
1501a1544,1578
> #ifdef WITH_TABS
> /**
>   Load tabs options from [Tabs] section.
> */
> void
> tabs_load_options (void)
> {
>     if (mc_config_has_group (mc_main_config, CONFIG_TABS_SECTION))
>     {
>         size_t i;
> 
>         for (i = 0; tabs_ini_options[i].opt_name != NULL; i++)
>             *tabs_ini_options[i].opt_addr =
>                 mc_config_get_bool (mc_main_config, CONFIG_TABS_SECTION,
>                                     tabs_ini_options[i].opt_name,
>                                     *tabs_ini_options[i].opt_addr);
> 
>         tabs_options.open_where = mc_config_get_int (mc_main_config, CONFIG_TABS_SECTION,
>                                    "open_where", (int) tabs_options.open_where);
>     }
> }
> 
> void
> tabs_save_options (void)
> {
>     size_t i;
> 
>     for (i = 0; tabs_ini_options[i].opt_name != NULL; i++)
>         mc_config_set_bool (mc_main_config, CONFIG_TABS_SECTION,
>                             tabs_ini_options[i].opt_name, *tabs_ini_options[i].opt_addr);
> 
>     mc_config_set_int (mc_main_config, CONFIG_TABS_SECTION,
>                        "open_where", (int) tabs_options.open_where);
> }
> #endif
